 
--[[
  ¦***************************************************¦
  ¦        Horizont, poloměr 70 řádků                 ¦
  ¦                                                   ¦
  ¦         *** ellet *** 2021 ***                    ¦
  ¦                                                   ¦
  ¦ Parametry kalX, kalY, kalZ (kalibrace X,Y,Z)      ¦
  ¦ slouží k nulování při nulové letové poloze.       ¦
  ¦ Zobrazení směru lze zakázat nastavením hodnoty    ¦ 
  ¦ 181 (nebo -181) v parametru kalZ.                 ¦
  ¦                                                   ¦
  ¦ Parametry invK, invV lze obrátit sklon            ¦
  ¦ aby vyhovoval poloze Rx a nastavení serv.         ¦
  ¦                                                   ¦
  ¦ Zápisem 1 do proměnné chXY lze zaměnit            ¦
  ¦ osy X a Y (pro přijímače ARCHER není třeba)       ¦
  ¦                                                   ¦
  ¦     (-; užívejte drobné radosti ;-)               ¦
  ¦***************************************************¦
--]]
 
local sroub = Bitmap.open("/WIDGETS/Hzont70/img/sroub.png")
local picture = Bitmap.open("/WIDGETS/Hzont70/img/plocha72.png")
local pict2 = Bitmap.open("/WIDGETS/Hzont70/img/AccZ48.png")

local chXY = 0 -- 1 přehodí osy X a Y
local XL = {}
local XP = {}
local Yb  = {}

local XLk = {}
local XPk = {}

local Sx = 0  
local Sy = 0 
local r = 70
local fl = 0


local tst=0
local tst_X=0
local tst_Y=0

local options = {
  {"kalX", VALUE, 0, -30, 30},  -- nastavení nuly 
  {"kalY", VALUE, 0, -30, 30},
  {"kalZ", VALUE, 0, -181, 181},
  {"invK", BOOL, 0},            -- opačný sklon
  {"invV", BOOL, 0}
 }
-----------------------------------------------------
local function create(zone, options)
 local wgt = {zone = zone, options = options}

if wgt.zone.h > 150 then

  if wgt.zone.x > 20 then
    Sx = wgt.zone.x + 64 -- + 60
    Sy = wgt.zone.y + 64     -- + 62
    for i=0, 2*r do 
      XL[i]=Sx-r+1 
      XP[i]=Sx+r+1
      Yb[i]=Sy+i-r
    end
  elseif wgt.zone.x < 21 then
    Sx = wgt.zone.x + 70
    Sy = wgt.zone.y + 62
    for i=0, 2*r do 
      XL[i]=Sx-r+1 
      XP[i]=Sx+r+1
      Yb[i]=Sy+i-r
    end
  end  -->20

for i=-r, r do  
  local y1 = Sy+i 
  local x1 = math.sqrt((r*r) - (i*i))
  XLk[i+r]=Sx-x1
  XPk[i+r]=Sx+x1
end

end

return wgt
end
-------------------------------------------------------
local function update(wgt, options)
  if (wgt == nil) then
    return
  end
  wgt.options = options
end
---------------------------------------------
local function background(wgt)
  return
end
--------------------------------------------------------
function round(num, decimals)
  local mult = 10^(decimals or 0)
  return math.floor(num * mult + 0.5) / mult
end
-------------------------------------------------------
local function oddo(kolik, co)
  if co>kolik then co = kolik end
  if co<-kolik then co = -kolik end
return co
end
---------------------------------------------------------
--------------------------------------------------------
---------------------------------------------------------
function refresh(wgt)

if (wgt == nil) then
  return
end
if (wgt.options == nil) then
  return
end
if wgt.zone.h < 145 then
 lcd.drawText(wgt.zone.x+2,wgt.zone.y+5, "Vyjmout!!!")
 return
end

lcd.drawText(wgt.zone.x+5,wgt.zone.y+20, "Vyjmout!!!")

local fl=0
local vys = 0
local kri = 0
local pX=0
local pY=0

if math.abs(wgt.options.kalZ) == 181 then 
  fl=1 else fl=0 end

if chXY==0 then
   vys = getValue("AccX")
   kri = getValue("AccY")
   vys = (vys*90) + wgt.options.kalX 
   kri = (kri*90) + wgt.options.kalY
   pX=math.floor(oddo(90,vys))
   pY=math.floor(oddo(90,kri))
else
   kri = getValue("AccX")
   vys = getValue("AccY")
   kri = (kri*90) + wgt.options.kalX 
   vys = (vys*90) + wgt.options.kalY
   pX=math.floor(oddo(90,kri))
   pY=math.floor(oddo(90,vys))
end

if wgt.options.invV==1 then vys = 0 - vys end
if wgt.options.invK==1 then kri = 0 - kri end

kri=math.floor(oddo(30,kri))
vys=math.floor(oddo(30,vys))

--------------------------------------------
lcd.setColor(LINE_COLOR, BLUE)
for i = 0, 4 do  
  lcd.drawLine(XL[i]+5-i,Yb[i],
               XP[i]-5+i,Yb[i], SOLID,LINE_COLOR)
end
for i = 5, 2*r do  
  lcd.drawLine(XL[i],Yb[i],
               XP[i],Yb[i], SOLID,LINE_COLOR)
end
--------------------------------------------
lcd.setColor(LINE_COLOR, YELLOW)
----------------------------------------------
if (kri==0) then    
  for i = r+vys, 2*r do  
    lcd.drawLine(XL[i],Yb[i],
                 XP[i],Yb[i], SOLID,LINE_COLOR)
  end
end 
----------------------------------------------
if kri>0 then
  local k2 = 2*kri
  local d = 0
  local p = -1
  local max = r+kri+vys
  if max>(2*r) then max=2*r end

  for i=r-kri+vys, max do  
    p=p+1
    d=p*(XP[i]-XL[i])/k2
    lcd.drawLine(XL[i],Yb[i],
                 XL[i]+d,Yb[i], SOLID,LINE_COLOR)
  end

  for i=max, 2*r do
   lcd.drawLine(XL[i],Yb[i],
               XP[i],Yb[i], SOLID,LINE_COLOR)
  end
end
-------------------------------------------------
if kri<0 then
  local kri1 = -kri
  local d = 0
  local k2 = 2*kri1
  local p = k2+1
  local max = r+kri1+vys
  if max>(2*r) then max=2*r end
 
  for i = r-kri1+vys, max do  
    p=p-1
    d=p*(XP[i]-XL[i])/k2
    lcd.drawLine(XL[i]+d,Yb[i],
                 XP[i],Yb[i], SOLID,LINE_COLOR)
  end
 
  for i=max, 2*r do
   lcd.drawLine(XL[i],Yb[i],
               XP[i],Yb[i], SOLID,LINE_COLOR)
  end
end -- if kri<0
--------------------------------------------------------
local rs = getValue("AccZ")
rs = rs * 100
rs = rs + wgt.options.kalZ

if rs<0 then rs=360-math.abs(rs) end
if rs>89 then rs = rs + 0.01 end

local xx = math.sin(rs/57.3) * 19
local yy = math.cos(rs/57.3) * 19
yy = -yy
----------------------------------------------------
lcd.drawBitmap(picture,Sx-73, Sy-75)        -- -75      -- -63,Sy-63)    
lcd.setColor(LINE_COLOR, RED)
lcd.drawLine(XL[r]-10, Sy, 
             XP[r]+10, Sy, SOLID,LINE_COLOR)
----------------------------------------
if fl == 0  then 
  lcd.setColor(LINE_COLOR, RED)
  lcd.drawBitmap(pict2, Sx-76, Sy-80) 
  lcd.drawLine(Sx-52+xx, Sy-56+yy, Sx-52, Sy-56, SOLID, LINE_COLOR)  -- -50
end
--------------------------------------------------
 lcd.setColor(CUSTOM_COLOR, BLACK)

 local vyska = getValue("Alt")
 if vyska<100 then 
   lcd.drawText(Sx-23, Sy-40, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED) 
 else
   lcd.drawText(Sx-30, Sy-40, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED)
 end
 lcd.setColor(CUSTOM_COLOR, RED)
 if vyska<100 then 
   lcd.drawText(Sx-24, Sy-41, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED) 
 else
   lcd.drawText(Sx-31, Sy-41, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED)
 end

 lcd.setColor(CUSTOM_COLOR, YELLOW) --BLACK) -- WHITE) -- 65535) -- RED) --YELLOW)
 local rssi = getValue("RSSI")
 local vfr = getValue("VFR")
 local a2 = getValue("A2")
 local vfas = getValue("VFAS")
 local nap = getValue("RxBt")
 local spd = getValue("VSpd")

 if a2<1 then 
   lcd.drawText(Sx+79, Sy+30, "A2:  --", CUSTOM_COLOR + SMLSIZE)--+ SHADOWED) 
 else
   lcd.drawText(Sx+77, Sy+30, "A2: "..round(a2,1), CUSTOM_COLOR + SMLSIZE)--+ SHADOWED) 
 end

 if vfas<1 then 
   lcd.drawText(Sx+65, Sy+57, "VFAS: --", CUSTOM_COLOR + SMLSIZE)--+ SHADOWED) 
 else
   lcd.drawText(Sx+65, Sy+57, "VFAS:"..round(vfas,1), CUSTOM_COLOR + SMLSIZE)--+ SHADOWED) 
 end

 if nap<10 then
   lcd.drawText(Sx+67, Sy+72, "RxBt : "..round(nap,1), CUSTOM_COLOR + SMLSIZE)--+ SHADOWED)
 else
   lcd.drawText(Sx+67, Sy+72, "RxBt :"..round(nap,1), CUSTOM_COLOR + SMLSIZE)--+ SHADOWED)
 end

 lcd.drawText(Sx-47, Sy+72, "VSpd: "..round(spd,1).." m/s", CUSTOM_COLOR + SMLSIZE)-- +SHADOWED)

 if vfr>99 then          --25
   lcd.drawText(Sx+74, Sy-40, "VFR: "..round(vfr), CUSTOM_COLOR+ SMLSIZE)-- + SHADOWED)
 elseif vfr>0 then
   lcd.drawText(Sx+78, Sy-40, "VFR: "..round(vfr), CUSTOM_COLOR + SMLSIZE)--+ SHADOWED)
 else
   lcd.drawText(Sx+78, Sy-40, "VFR: ".." --", CUSTOM_COLOR + SMLSIZE)--+ SHADOWED)
 end

 if rssi>99 then
   lcd.drawText(Sx+68, Sy-62, "RSSI: "..round(rssi), CUSTOM_COLOR+ SMLSIZE)-- + SHADOWED)
 else
   lcd.drawText(Sx+72, Sy-62, "RSSI: "..round(rssi), CUSTOM_COLOR+ SMLSIZE)-- + SHADOWED)
 end

 lcd.drawText(Sx+83, Sy-18, "X   "..pX, CUSTOM_COLOR + SMLSIZE)--+ SHADOWED) 
 lcd.drawText(Sx+83, Sy+5, "Y   "..pY, CUSTOM_COLOR + SMLSIZE)--+ SHADOWED) 

 lcd.drawBitmap(sroub,Sx+55,Sy-60) -- pravý horní
 lcd.drawBitmap(sroub,Sx+55,Sy+51)
 lcd.drawBitmap(sroub,Sx-60,Sy+51) 
 if fl==1 then
   lcd.drawBitmap(sroub,Sx-60,Sy-60) 
 end

 lcd.setColor(LINE_COLOR, GREY)
 return
end

return {
  name = "Hzont70",
  options = options,
  create = create,
  update = update,
  background = background,
  refresh = refresh
}